<?php
/**
 * Plugin Name: C.N.Gann Shortcodes
 * Plugin URI: http://www.cngann.com
 * Description: Shortcodes used by C.N.Gann Technology Group in their WordPress sites.
 * Version: 2.3.3
 * Author: mflynn, cngann
 * Author URI: http://cngann.com
 * License: GPL2
 */
	ini_set('display_errors',1);
	error_reporting(E_ERROR);

	$___FILE___ = __FILE__;
	if ( isset( $plugin ) ) $___FILE___ = $plugin;
	else if ( isset( $mu_plugin ) ) $___FILE___ = $mu_plugin;
	else if ( isset( $network_plugin ) ) $___FILE___ = $network_plugin;
	define( '___FILE___', $___FILE___ );
	$___DIR___ = dirname(___FILE___);
	define( '___DIR___', $___DIR___);

	function cngann_get_image($i){
		$r = false;
		if(is_numeric($i)) $r = wp_get_attachment_image_src($i,'full')[0]; // ID
		else if(str_replace('//','',$i) != $i) $r = $i; // is external link
		else if(file_exists( ___DIR___ . '/' . $i) ) $r = plugins_url($i,___FILE___);
		return $r;
	}

	function cngann_get_url($i){
		global $wpdb;
		if($i === '#') return $i;
		if($i === '') return $i;
		if(is_numeric($i)) return get_permalink($i); // ID
		else if(str_replace('//','',$i) != $i) return $i; // is external link
		else if(file_exists( ___DIR___ . '/' . $i) ) return plugins_url($i,___FILE___);
		else if($wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE post_name = '{$i}'")) return get_permalink($wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE post_name = '{$i}'"));
		else return $i; // relative link
		return $i;
	}

	function cngann_get_size($i){
		if($i != str_replace('px','',$i)) return $i;
		if($i != str_replace('%','',$i)) return $i;
		if($i != str_replace('em','',$i)) return $i;
		if($i != str_replace('pt','',$i)) return $i;
		if($i != str_replace('in','',$i)) return $i;
		if(is_numeric($i)) return $i . 'px';
		return false;
	}

	add_action( 'wp_enqueue_scripts', function(){
		wp_enqueue_script('cngann_tabs', 	plugins_url( '/js/tabs.js',		___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_more', 	plugins_url( '/js/more.js',		___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_slider',	plugins_url( '/js/slider.js',		___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_flashcard',	plugins_url( '/js/flashcard.js',	___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_linkmap',	plugins_url( '/js/link_map.js',		___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_splits',	plugins_url( '/js/splits.js',		___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_script('cngann_emailform',	plugins_url( '/js/email_form.js',	___FILE___ ), array('jquery'), '1.0');
		wp_enqueue_style('cngann_style',	plugins_url( '/css/style.css',		___FILE___ ), array(), '1.0' );
	},11);

	add_action('init',function(){
		if(!$_GET['send_form']) return;
		echo "success";
		die;
	});


	/* Splits */

	add_shortcode('splits', function($atts, $content){
		extract(shortcode_atts(array(
		),$atts,'splits'));
		return "<div class='splits'>".do_shortcode($content).do_shortcode('[clear]')."</div>";
	});

	add_shortcode('one_half', function($atts, $content){
		extract(shortcode_atts(array(
			'right' =>false,
			'left' => false
		),$atts,'one_half'));
		return "<div class='split half one ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('one_third', function($atts, $content){
		extract(shortcode_atts(array(
			'right' => false,
			'left' => false
		),$atts,'one_third'));
		return "<div class='split third one ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('two_thirds', function($atts, $content){
		extract(shortcode_atts(array(
			'right' =>false,
			'left' => false
		),$atts,'two_thirds'));
		return "<div class='split third two ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('one_fourth', function($atts, $content){
		extract(shortcode_atts(array(
			'right' =>false,
			'left' => false
		),$atts,'one_fourth'));
		return "<div class='split fourth one ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('two_fourths', function($atts, $content){
		extract(shortcode_atts(array(
			'right' =>false,
			'left' => false
		),$atts,'two_fourths'));
		return "<div class='split fourth two ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('three_fourths', function($atts, $content){
		extract(shortcode_atts(array(
			'right' =>false,
			'left' => false
		),$atts,'three_fourths'));
		return "<div class='split fourth three ". ( $left ? "l" : "" ) ." ".($right ? "r" : "")." '>".do_shortcode(wpautop($content, true))."</div>";
	});

	/* Clear */

	add_shortcode('clear', function(){
		extract(shortcode_atts(array(
		),$atts,'clear'));
		return "<div style='clear:both;'></div>";
	});

	/* More */

	add_shortcode('more', function($atts, $content){
		extract(shortcode_atts(array(
			'title'=>"Learn More..."
		),$atts, 'more'));
		return "<div class='more'><a href='#'>{$title}</a><div style='display:none;' class='the_more'>".do_shortcode(wpautop($content, true))."</div></div>";
	});

	add_shortcode('spoiler', function($atts, $content){
		extract(shortcode_atts(array(
			'title'=>"SPOILER"
		),$atts, 'spoiler'));
		return "<div class='more'><a href='#'>{$title}</a><div style='display:none;' class='the_more'>".do_shortcode(wpautop($content, true))."</div></div>";
	});

	add_shortcode('spoil', function($atts, $content){
		extract(shortcode_atts(array(
			'title'=>"SPOILER"
		),$atts, 'spoil'));
		return "<div class='more'><a href='#'>{$title}</a><div style='display:none;' class='the_more'>".do_shortcode(wpautop($content, true))."</div></div>";
	});

	/* Tabs */

	add_shortcode('tabs', function($atts, $content){
		extract(shortcode_atts(array(
		),$atts,'tabs'));
		return "<div class='tabs'>".do_shortcode($content)."</div>";
	});

	add_shortcode('tab', function($atts, $content){
		extract(shortcode_atts(array(
			'title'=>"",
			'ttl' => ""
		),$atts, 'tab'));
		return "<div class='tab' ttl='".($title != "" ? $title : ($ttl != "" ? $ttl : "New Tab"))."'>".do_shortcode(wpautop($content, true))."</div>";
	});

	/* Slider */

	add_shortcode('slider', function($atts, $content){
		extract(shortcode_atts(array(
			'first'=>false,
			"height" => "",
			"h"=>""
		),$atts, 'slider'));
		$h = $height ? $height : $h ? $h : "";
		$h = cngann_get_size($h);
		return "<div class='slider ".( $first != '' ? 'first' : '' )."' hh='".( $h ? $h : "" )."' >".do_shortcode($content)."</div>";
	});

	add_shortcode('slide', function($atts, $content){
		extract(shortcode_atts(array(
			'href'=>false,
			'id' => false,
			'link' => false,
			'slug' => false,
		),$atts, 'slide'));
		$href = cngann_get_url( $href ? $href : ($id ? $id : ($link ? $link : ($slug ? $slug : "#") ) ) );
		return "<div class='slide' href='{$href}'>".do_shortcode($content)."</div>";
	});

	/* Hover */

	add_shortcode('hover', function($atts, $content){
		extract(shortcode_atts(array(
		),$atts,'hover'));
		return "<div class='hover'>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('on', function($atts, $content){
		extract(shortcode_atts(array(
		),$atts,'on'));
		return "<div class='on'>".do_shortcode(wpautop($content, true))."</div>";
	});

	add_shortcode('off', function($atts, $content){
		extract(shortcode_atts(array(
		),$atts,'off'));
		return "<div class='off'>".do_shortcode(wpautop($content, true))."</div>";
	});

	/* Person */

	add_shortcode('person', function($atts, $content){
		extract(shortcode_atts(array(
			'src'=>  plugins_url('/images/def_person.png', ___FILE___),
			'name' => "",
			'jobtitle' => "",
			'email' => "",
			'phone' => ""
		),$atts, 'person'));
		$src = cngann_get_image($src);
		return "
			<div class='person'>
				<img src='{$src}'>".
				( $name ? "<strong>{$name}</strong><br>" : "").
				( $jobtitle ? "<em>{$jobtitle}</em><br>" : "").
				( $email ? "<a href='mailto:{$email}'>Contact by Email</a><br>" : "").
				( $phone ? "<a href='tel:{$phone}'>{$phone}</a><br>" : "").
				"
			</div>
		";
	});

	/* Background */

	add_shortcode('background', function($atts, $content){
		extract(shortcode_atts(array(
			'src'=>"",
			'height' => "",
			'width' => "",
			'class' => "",
			'bgcolor' => "transparent",
			'color' => "inherit",
			'repeat' => "no-repeat",
			'position' => "top left",
			'padding' => "0px 0px 0px 0px"
		),$atts, 'background'));
		$src = cngann_get_image($src);
		$height = cngann_get_size($height);
		$width = cngann_get_size($width);
		return "<div class='background ".$class." ' style=\" color: {$color}; background: {$bgcolor} " . ($src ? "url('{$src}') {$repeat} {$position} ":"") . "; padding:{$padding}; min-height:{$height}; ".($width ? "width:{$width}; display: inline-block;":"display: block;")."\" >".do_shortcode(wpautop($content, true))."</div>";
	});

	/* Flash Card */

	add_shortcode('flashcard', function($atts, $content){
		extract(shortcode_atts(array(
			'height' => '0',
			'width' => '0',
			'class' => ''
		), $atts, 'flashcard'));
		$height = cngann_get_size($height);
		$width = cngann_get_size($width);
		return "<div class='flashcard ".$class."' style='".($height ? 'height:'.$height.';' : '')." ".($width ? 'width:'.$width.';' : '')."' ><div class='card'>".do_shortcode(wpautop($content, true))."</div></div>";
	});

	add_shortcode('front', function($atts, $content){
		extract(shortcode_atts(array(
			'click' => 'all'
		),$atts,'front'));
		return "<figure class='front' click='{$click}'>".do_shortcode(wpautop($content, true))."</figure>";
	});

	add_shortcode('back', function($atts, $content){
		extract(shortcode_atts(array(
			'click' => 'all'
		),$atts,'back'));
		return "<figure class='back' click='{$click}'>".do_shortcode(wpautop($content, true))."</figure>";
	});

	/* Link Map */

	add_shortcode('linkmap', function($atts, $content){
		extract(shortcode_atts(array(
			'height' => '',
			'width' => '',
			'class' => '',
			'src'	=> '',
			'hover_src' => '',
			'flashcard' => '',
			'bgcolor'   => 'transparent',
		), $atts, 'linkmap'));
		$height = cngann_get_size($height);
		$width = cngann_get_size($width);
		$flashcard = $flashcard != '';
		$src = cngann_get_image($src);
		$hover_src = cngann_get_image($hover_src);
		return "<linkmap class='".$class." " . ($flashcard ? "fc' fc=\"{$flashcard}\"" : "'") . "  src='".$src."' style=\"height:{$height}; width:{$width}; background: {$bgcolor} url('{$src}') no-repeat top left; \" h='".$height."' w='".$width."' ".($hover_src ? " hoverSrc='{$hover_src}' " : '')." >".do_shortcode($content)."</linkmap>";
	});

	add_shortcode('maplink', function($atts, $content){
		extract(shortcode_atts(array(
			'height' => '0',
			'width' => '0',
			'class' => '',
			'top' => '0',
			'left' => '0',
			'href'=>false,
			'id' => false,
			'link' => false,
			'slug' => false,
			'fc' => ''
		), $atts, 'map_link'));
		$href = cngann_get_url( $href ? $href : ($id ? $id : ($link ? $link : ($slug ? $slug : "#") ) ) );
		$height = cngann_get_size($height);
		$width = cngann_get_size($width);
		return "<maplink class='link {$class}' fc=\"{$fc}\" style=\"height:{$height}; width:{$width}; top: {$top}; left:{$left};\"  h='".$height."' w='".$width."' ltop='".$top."' lleft='".$left."' href=\"{$href}\">".do_shortcode(wpautop($content, true))."</maplink>";
	});

	add_shortcode('link', function($atts, $content){
		extract(shortcode_atts(array(
			'href'	=> false,
			'id' 	=> false,
			'link' 	=> false,
			'slug' 	=> false,
			'class'	=> ""
		),$atts, 'link'));
		if(!$content){
			if( is_numeric( $href ? $href : ($id ? $id : ($link ? $link : ($slug ? $slug : "#") ) ) ) ) $content ="[title id='".$href ? $href : ($id ? $id : ($link ? $link : ($slug ? $slug : "#") ) )."']";
		}
		return "<a href='".cngann_get_url( $href ? $href : ($id ? $id : ($link ? $link : ($slug ? $slug : "#") ) ) )."' class='{$class}'".do_shortcode(wpautop($content, true))."</a>";
	});

	add_shortcode('title', function($atts, $content){
		extract(shortcode_atts(array(
			'id'=>"",
			'slug'=>""
		),$atts, 'link'));
		if(!$id && $slug) $id = $wpdb->get_var("SELECT ID FROM {$wpdb->posts} WHERE post_name = '{$slug}'");
		if($id) $title = get_the_title($id);
		else $title = get_the_title();
		return $title;
	});

	add_shortcode('button', function($atts,$content){
		extract(shortcode_atts(array(
			'title' => 'Submit',
			'class' => ""
		),$atts, 'button'));
		return "<div class='button {$class}'>{$title}</div>";
	});

	add_shortcode('buttons', function($atts,$content){
		extract(shortcode_atts(array(
			'align' => "right"
		),$atts, 'buttons'));
		return "<div class='buttons' style='text-align:{$align}'>".do_shortcode($content)."</div>";
	});


	add_shortcode('email_form', function($atts, $content){
		extract(shortcode_atts(array(
			'height' => '620px',
			'width' => '100%',
			'title' => 'Get Connected',
			'above_form' => "Please enter your contact information and we will connect with you to answer any and all of your questions.",
			'email' => 'Email Address',
			'name' => 'First and Last Name',
			'company' => 'Company Name',
			'phone' => 'Phone Number',
			'content' => 'Comments',
			'get_emails' => 'Yes, I would like to receive the newsletters.',
			'button' => 'Get Connected',
			'type' => 'email',
			'error' => "There was an error connecting you.",
			'success' => "You are now connected."
		),$atts, 'email_form'));
		$height = cngann_get_size($height);
		$width = cngann_get_size($width);
		$form = "<div class='email_form' height='{$height}' width='{$width}' error=\"{$error}\" success=\"{$success}\">".
				"<p>{$above_form}</p>".
				"<input type='hidden' name='email_form' value='{$type}' />".
				"<input type='text' name='name' value='' placeholder='{$name}' />".
				"<input type='text' name='company' value='' placeholder='{$company}' />".
				"<input type='text' name='email' value='' placeholder='{$email}' />".
				"<input type='text' name='phone' value='' placeholder='{$phone}' />".
				"<textarea name='content' placeholder='{$content}'></textarea>".
				"<p><input type='checkbox' name='get_emails' value='y'>{$get_emails}</p>".
				"[buttons align='right'][button title='{$button}' class='submit'][/buttons]".
			"</div>";
		return do_shortcode($form);
	});

?>